function [root]=backward_solve(input)				#the main function which computes the answer
	root=zeros(rows(input),columns(input));			#an initial zero matrix of the same size as input
	A=get_conversion_matrix(input);					#the get_conversion_matrix call which gives us the matrix used to convert action vector to effect vector
	B=col_conv(input);								#converting input into col matrix
	x=det(A)*inv(A)*B;								#finding out the answer in column matirx form
	root=back_conv(x,rows(input),columns(input));	#converting the answer column back into an m X n matrix form
	root=int32(root);								#removing the ugly decimals
	root=mod(root,2);								#returns the root
endfunction